︠4abfdc82-748d-49ae-b8c6-ecb6c823d259s︠
class logSpiral:
    def __init__(self):
       self.size = 0
       self.points = []
       self.pointsR = []
       self.g = Graphics()
          
    def normal(self,xyPoints,xyI):
        var('x')
        aPoint = xyPoints[0]
        bPoint = xyPoints[1]
        #deltay = 0
        if bPoint[1] == aPoint[1]:
            return 0
        #deltax = 0
        if bPoint[0] == aPoint[0]:
            return 1e6
        m = -(bPoint[0] - aPoint[0])/ (bPoint[1] - aPoint[1])
        b = xyI[1] - m*xyI[0]
        return N(m)*x + b

    def eqnLine(self,aPoint,bPoint):
        var('x')
        yb = bPoint[1]
        ya = aPoint[1]
        xb = bPoint[0]
        xa = aPoint[0]
        m = (yb - ya) / (xb -xa)
        return m*(x - xa) + ya
    
    def doSpiral(self,n,c):
        #print "doSpiral received n, c",n,c
        self.points= [[[0.0,0.0],[ N(7*cos(pi*k/6.0)), N(6*sin(pi*k/6.0))]] for k in range(n)]
        self.pointsR =  [[[0.0,0.0],[ N(7*cos(pi*k/6.0)), N(6*sin(pi*k/6.0))]] for k in range(n,0,-1)]
        spiral = self.pointsR if c == True else self.points
        #print spiral
        px = spiral[0][1][0]/5.0
        py = spiral[0][1][1]/5.0
        x,y = var('x','y')
        self.g = Graphics()
        lprev = None
        ptIx = None
        #self.g = polar_plot([ r for r in range(1,8)],(x,0,2*pi))
        #debug issue 1 fixed - keep one color for all circles by not using polar plot
        for r in range(1,8):
            self.g += circle((0,0),r)
        for i in range(n):
            lxy = spiral[i]
            #print "lxy",lxy
            self.g += line(lxy)
            if lprev <> None:
                slopeExp =  self.eqnLine(lxy[0],lxy[1])
                eqn = y - slopeExp
                #print "eqn {}".format(eqn)
                if eqn == y:
                    #print "lxy and lprev for horizontal{} {}".format(lxy,lprev[1])
                    norm = y - self.eqnLine(lprev[1],lxy[1])
                    #print "adjusting norm {}".format(norm)
                else:
                    deltaY = lprev[1][1] - lprev[0][1]
                    if deltaY == 0:
                        ptIx = px
                        yy = self.eqnLine(lxy[0],lxy[1])
                        ptIy = yy.subs(x=px)
                    else:
                        norm = y - self.normal([[0.0,0.0],[px,py]],[px,py])
                        #print "eqn",eqn
                        #print "norm",norm
                        pointI = solve([eqn,norm],x,y,solution_dict=True)
                       
                        ptIx = N(pointI[0][x])
                        ptIy = N(pointI[0][y])
                        #print "debug point of intersection",N(ptIx),N(ptIy)
                    gn = line([[px,py],[ptIx,ptIy]],color='red')
                    self.g += gn
            lprev = lxy
            if ptIx <> None:
                px = ptIx
                py = ptIy
        self.g.show()    
        #return self.g
    
    def magnitude(self):
        #sage doesn't like classes using keywords size or length for methods!!!
        return self.size

    def remove(self,n):
        self.g = None

logspiral = logSpiral()
@interact
def logSpiralInteract(n = slider(1,100,1,12, label="Radials"),c = checkbox(False,"Reverse")):
    logspiral.doSpiral(n,c)
︡5d6ce8e9-f2f9-4552-a32e-58bee499ab75︡{"interact":{"controls":[{"animate":true,"control_type":"slider","default":11,"display_value":true,"label":"Radials","vals":["1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31","32","33","34","35","36","37","38","39","40","41","42","43","44","45","46","47","48","49","50","51","52","53","54","55","56","57","58","59","60","61","62","63","64","65","66","67","68","69","70","71","72","73","74","75","76","77","78","79","80","81","82","83","84","85","86","87","88","89","90","91","92","93","94","95","96","97","98","99","100"],"var":"n","width":null},{"control_type":"checkbox","default":false,"label":"Reverse","readonly":false,"var":"c"}],"flicker":false,"id":"49f08cb5-5956-4aad-9958-8adb4757e981","layout":[[["n",12,null]],[["c",12,null]],[["",12,null]]],"style":"None"}}︡{"done":true}︡
︠7c3a4ec5-ea59-42ed-a971-4fbd4581bff6s︠
show(graphs.PetersenGraph().plot3d(), frame=False)
parametric_plot([cos(x) + 2*cos(x/4), sin(x) - 2*sin(x/4)], (x,0,8*pi), color='green', thickness=3, fill = True)
︡54fa1f93-b278-40ea-b174-57c455d37085︡{"file":{"filename":"c449a64d-741c-4ada-b239-723619bd7183.sage3d","uuid":"c449a64d-741c-4ada-b239-723619bd7183"}}︡{"stderr":"/ext/sage/sage-8.0/local/lib/python2.7/site-packages/matplotlib/font_manager.py:273: UserWarning: Matplotlib is building the font cache using fc-list. This may take a moment.\n  warnings.warn('Matplotlib is building the font cache using fc-list. This may take a moment.')\n"}︡{"file":{"filename":"/home/user/.sage/temp/project-73972b06-2c86-4a2d-9649-d9fbfdede834/114/tmp_7muONx.svg","show":true,"text":null,"uuid":"af1ec063-bf6c-4697-ac6c-7a78719d659d"},"once":false}︡{"done":true}︡
︠cb6cbb5d-94b7-44c1-b9ef-780f9441f0f6s︠
︡3e0a2cbc-8c5c-40ce-98ff-b24c31496f00︡{"done":true}︡
︠91476821-d346-4bf8-a62b-33ced26611b9r︠
CC
continued_fraction(e)
︡81352b7e-6bf0-4cbf-b167-8876d961a145︡
︠915e400c-14bb-4583-8633-d4597f448d9bio︠










